int set_sensor_frames_per_second(int fps, float *used);
int convert_jpeg_in_buffer_to_gstream(int *bytes_in_buffer);
int convert_mpeg_in_buffer_to_gstream(int *bytes_in_buffer);
int convert_wavelet_in_buffer_to_gstream(int *bytes_in_buffer);
int make_wavelet_in_buffer(int *bytes_read);
int make_mpeg_in_buffer(int *bytes_read);
int make_jpeg_in_buffer(int *bytes_read);
int y_u_v_files_to_gstream(unsigned char *inbuffer, int *bytes_in_buffer);
int gstream_to_y_u_v_files(\
	int xsize, int ysize, unsigned char *inbuffer, int inbuffer_size,\
	int compression_flag);
int convert(\
	unsigned char *ibuf, int ibufsize, unsigned char *obuf, int type);
int main(int argc, char *argv[]);
BOOL CheckForCPIA( BYTE PortNumber );
BOOL DoSystemTest( void );
void UploadAndSaveDRAM( void );
BOOL UploadTestData( WORD DummyBlocks );
void DoUploadImage( void );
BOOL TestEEPROM( void );
int wait_key();
int console_status();
int get_port_base_address(int *address);
int read_and_display_frame(char *filename, int argc, char **argv);
int get_a_frame(int *bytes_read, int coding_mode);
int display_a_frame(\
	int argc, char **argv,\
	int bytes_in_buffer, int coding_mode, int compression_flag);
int text_to_gstream(\
	unsigned char *text, int x, int y,\
	int fr, int fg, int fb,\
	int br, int bg, int bb,\
	BYTE __huge *buffer);
char *get_time_as_string(int short_format_flag, int ut_flag);
int add_clock(BYTE __huge *buffer);
BOOL CPIA_CmdInit( int UnusedParameter );
void CPIA_CmdFini( void );
BOOL CPIA_GetVersion( BYTE *FW_Version, BYTE *FW_Revision,
				 BYTE *VC_Version, BYTE *VC_Revision );
BOOL CPIA_GetPnPID( WORD *VendorID, WORD *ProductID, WORD *DeviceID );

/*
BOOL CPIA_GetCameraStatus( BYTE *SystemState, BYTE *VPCtrlState,
						   BYTE *StreamState, BYTE *FatalError,
						   BYTE *CmdError,    BYTE *DebugFlags,
						   BYTE *VPStatus,    BYTE *ErrorCode );
*/

BOOL CPIA_GetCameraStatus( BYTE *a, BYTE *b,\
						   BYTE *c, BYTE *d,\
						   BYTE *e, BYTE *f,\
						   BYTE *g, BYTE *h );
BOOL CPIA_GotoHiPower( void );
BOOL CPIA_GotoLoPower( void );
BOOL CPIA_GotoSuspend( void );
BOOL CPIA_GotoPassThrough( void );
BOOL CPIA_ModifyCameraStatus( BYTE StatusByte, BYTE AndMask, BYTE OrMask );
BOOL CPIA_ReadVCRegs( BYTE Addr0, BYTE Addr1, BYTE Addr2, BYTE Addr3,
						BYTE *Reg0, BYTE *Reg1, BYTE *Reg2, BYTE *Reg3 );
BOOL CPIA_WriteVCReg( BYTE Addr, BYTE AndMask, BYTE OrMask );
BOOL CPIA_ReadMCPorts( BYTE *Port0, BYTE *Port1, BYTE *Port2, BYTE *Port3 );
BOOL CPIA_WriteMCPort( BYTE Port, BYTE AndMask, BYTE OrMask );
BOOL CPIA_SetBaudRate( DWORD BaudRate );
BOOL CPIA_SetECPTiming( BOOL SlowTiming );
BOOL CPIA_ReadIDATA( BYTE Addr0, BYTE Addr1, BYTE Addr2, BYTE Addr3,
						BYTE *Byte0, BYTE *Byte1, BYTE *Byte2, BYTE *Byte3 );
BOOL CPIA_WriteIDATA( BYTE Addr, BYTE AndMask, BYTE OrMask );
BOOL CPIA_GenericCall( WORD CallAddr );
BOOL CPIA_SerialStart( void );
BOOL CPIA_SerialStop( void );
BOOL CPIA_SerialWrite( BYTE WriteData );
BOOL CPIA_SerialRead( BOOL AckRead, BYTE *ReadData );
BOOL CPIA_GetVPVersion( BYTE *VP_Version, BYTE *VP_Revision,
	 				  BYTE *Sensor_Version, BYTE *Sensor_Revision );
BOOL CPIA_SetColourParams( BYTE Brightness, BYTE Contrast, BYTE Saturation );
BOOL CPIA_SetExposure( \
BYTE GainMode, BYTE ExpMode, BYTE CompMode, BYTE CentreWeight,
BYTE Gain, BYTE FineExp, BYTE CoarseExpLo, BYTE CoarseExpHi, 
BYTE RedComp, BYTE Green1Comp, BYTE Green2Comp, BYTE BlueComp );
BOOL CPIA_SetColourBalance( BYTE BalanceMode, BYTE RedGain,
							BYTE GreenGain, BYTE BlueGain );
BOOL CPIA_SetSensorFPS( BYTE SensorClkDivisor, BYTE BaseRate );
BOOL CPIA_SetVPDefaults( void );
BOOL CPIA_SetApcor( BYTE ApCorGain1, BYTE ApCorGain2, BYTE ApCorGain4, BYTE ApCorGain8 );
BOOL CPIA_FlickerCtrl( BYTE FlickerMode, BYTE CoarseJump, BYTE AllowableOverExposure );
BOOL CPIA_SetVLOffset( BYTE VLOffsetGain1, BYTE VLOffsetGain2, BYTE VLOffsetGain4, BYTE VLOffsetGain8 );
BOOL CPIA_GetColourParams( BYTE *Brightness, BYTE *Contrast, BYTE *Saturation );
BOOL CPIA_GetColourBalance( BYTE *RedGain, BYTE *GreenGain, BYTE *BlueGain );
BOOL CPIA_GetExposure( 	BYTE *Gain, BYTE *FineExp, BYTE *CoarseExpLo, BYTE *CoarseExpHi, 
					   		BYTE *RedComp, BYTE *Green1Comp, BYTE *Green2Comp, BYTE *BlueComp );
BOOL CPIA_SetSensorMatrix( BYTE Matrix[9] );
BOOL CPIA_ColourBars( BOOL EnableColourBars );
BOOL CPIA_ReadVPRegs( BYTE Addr0, BYTE Addr1, BYTE Addr2, BYTE Addr3,
						BYTE *Reg0, BYTE *Reg1, BYTE *Reg2, BYTE *Reg3 );
BOOL CPIA_WriteVPReg( BYTE Addr, BYTE AndMask, BYTE OrMask );
BOOL CPIA_GrabFrame( byte StreamStartLine );
BOOL CPIA_UploadFrame( byte ForceUpload );
BOOL CPIA_SetGrabMode( byte ContinuousGrab );
BOOL CPIA_InitStreamCap( byte SkipFrames, byte StreamStartLine );
BOOL CPIA_FiniStreamCap( void );
BOOL CPIA_StartStreamCap( void );
BOOL CPIA_StopStreamCap( void );
BOOL CPIA_SetFormat(  BYTE VideoSize, BYTE SubSampling, BYTE YUVOrder );
BOOL CPIA_SetROI( BYTE ColStart, BYTE ColEnd, BYTE RowStart, BYTE RowEnd );
BOOL CPIA_SetCompression( BYTE CompMode, BYTE Decimation );
BOOL CPIA_SetCompressionTarget( BYTE FRTargetting, BYTE TargetFR, BYTE TargetQ );
BOOL CPIA_SetYUVThresh( BYTE YThresh, BYTE UVThresh );
BOOL CPIA_SetCompressionParams( BYTE Hysteresis, BYTE ThreshMax, BYTE SmallStep, BYTE LargeStep, 
								BYTE DecimationHysteresis, BYTE FRDiffStepThresh, BYTE QDiffStepThresh,
								BYTE DecimationThreshMod );
BOOL CPIA_DiscardFrame( void );
BOOL CPIA_GrabReset( void );
BOOL CPIA_OutputRS232( char String[8] );
BOOL CPIA_AbortProcess( void );
BOOL CPIA_NullCmd( void );
BOOL CPIA_SetDRAMPage( WORD StartPage, WORD EndPage );
BOOL CPIA_StartDRAMUpload( void );
BOOL CPIA_StartDummyStream( void );
BOOL CPIA_AbortStream( void );
BOOL CPIA_UploadStreamData( DWORD MaxBytes, byte __huge *Buffer, DWORD *ActualBytes, DWORD StreamChunkSize );
BOOL CPIA_MACRO_TestStream( WORD StartPage, WORD EndPage, BYTE __huge *Buffer );
BOOL CPIA_MACRO_UploadDRAM( WORD StartPage, WORD EndPage, BYTE __huge *Buffer );
BOOL CPIA_MACRO_DownloadDRAM( WORD StartPage, WORD EndPage, BYTE __huge *Buffer );
BOOL CLINK_Init( void );
void CLINK_Fini( void );
BOOL CLINK_DetectPort( BYTE PortNumber, WORD *BaseAddr, BYTE *PortType );
BOOL CLINK_SelectPort( BYTE PortNumber );
BOOL CLINK_GetSelectedPort( BYTE *PortNumber );
BOOL CLINK_SendWakeup( void );
BOOL CLINK_Get1284DeviceID( char *DeviceID, WORD MaxLength );
BOOL CLINK_ForceWatchdogReset( void );
BOOL CLINK_GetPortInfo( WORD *PortAddr, BYTE *PortType, WORD *Timeout_mS );
BOOL CLINK_SetPortInfo( BYTE PortType, WORD Timeout_mS );
int Get1284DeviceID( char __huge *DestString );
BOOL CLINK_TransferMsg( BYTE  Module, BYTE  Proc, CMD_DATA *CmdData,
	BOOL DataReadFlag, WORD DataBytes, DATA_BUFFER *DataBuffer );
BOOL CLINK_UploadStreamData(
BOOL EndOnFF, DWORD DataBytes, BYTE  __huge *DataBuffer,\
DWORD *ActualBytes, DWORD StreamChunkSize );
int p_effect(BYTE __huge *buffer, int in_size);
int process_yuyv(\
	BYTE __huge *y1, BYTE __huge *u, BYTE __huge *y2, BYTE __huge *v,\
int y_val, int u_val, int v_val,\
int y_width, int u_width, int v_width,\
int y_replace, int u_replace, int v_replace);
int detect_change(\
	BYTE __huge *buffer, int in_size, int *change_flag,\
int y_difference, int u_difference, int v_difference, int treshhold);
int detect_object(\
	BYTE __huge *buffer, int in_size, int *change_flag,\
int y_difference, int u_difference, int v_difference, int treshhold,\
char ref_y_matrix[], char ref_u_matrix[], char ref_v_matrix[],\
int ref_hsize, int ref_vsize);
int test_test(BYTE __huge *buffer, int bytes_in_buffer,\
int y_difference, int u_difference, int v_difference, int treshhold);
int init_sockaddr (\
struct sockaddr_in *name, const char *hostname, unsigned short int port);
int read_from_server(\
int argc, char **argv, char *server, int port, char *password);
int construct_camera_command(char *text, BYTE __huge *buffer);
int show_commands();
int save_status(BYTE __huge *buffer, FILE *fptr);
int show_camera_status(BYTE __huge *buffer);
int execute_local_commands(char *text);
int make_socket (unsigned short int port);
int accept_connections(int argc, char **argv, int port, int coding_mode);
int execute_camera_command(BYTE __huge *buffer, int *coding_mode);
int restart_camera();
int camera_status_to_buffer(BYTE __huge *buffer);
int server_status_to_buffer(\
	BYTE __huge *buffer, int clients,\
	float bytes_per_second, float frames_per_second);
int gstream_to_ppm(\
	int xsize, int ysize, unsigned char *inbuffer, int inbuffer_size,\
	FILE *fptr, int compression_flag);
int ppm_to_gstream(\
	char *filename, BYTE __huge *out_buffer, int *bytes_in_buffer);
int DetectPortType( BYTE PortNumber, PPORT *Port );
int InitialisePPort( PPORT *Port );
void ClosePPort( PPORT *Port );
int SendVPP( PPORT *Port, BYTE Bytes, BYTE *Buffer );
int GetTimeout( PPORT *Port, WORD *Timeout_mS );
int SetTimeout(  PPORT *Port, WORD Timeout_mS );
int SetTransferMode( PPORT *Port, BYTE NewMode );
int EndTransferMode( PPORT *Port );
int SetUploadMode( PPORT *Port, BYTE UploadMode, BYTE ModeFlags );
int EndUploadMode( PPORT *Port );
int Attempt1284Negotiation( PPORT *Port );
int Forward2Reverse( PPORT *Port );
int Reverse2Forward( PPORT *Port );
int ECPWriteBuffer( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int ECPReadBuffer( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int SimECPWriteBuffer( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int SimECPReadBuffer( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
BYTE UnscrambleNibble( BYTE Data );
int NibbleReadBuffer( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int ECPUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
void SetCOMPATMode( PPORT *Port );
int Negotiate2SetupPhase(\
PPORT *Port, BYTE ExtensibilityByte, BYTE LinkMode );
int ANegotiate2SetupPhase( PPORT *Port, BYTE ExtensibilityByte, BYTE LinkMode );
int Valid1284Termination( PPORT *Port );
void Immediate1284Termination( PPORT *Port );
int  ECPSetupPhase( PPORT *Port );
int AttemptForward2Reverse( PPORT *Port );
int  NibbleSetupPhase( PPORT *Port );
WORD TestPortType( WORD BaseAddr );
int TestGenericECP( WORD BaseAddr );
void SetECRMode( PPORT *Port, BYTE Mode );
BYTE GetECRBit( PPORT *Port, BYTE BitMask );
void EmptyFIFO( PPORT *Port );
void SetDataDirection( PPORT *Port, BYTE NewDirection );
void PutData( PPORT *Port, BYTE Data );
BYTE GetData( PPORT *Port );
BYTE GetStatus( PPORT *Port );
BYTE GetControl( PPORT *Port );
void PutControl( PPORT *Port, BYTE Data );
BYTE GetStatusBit( PPORT *Port, BYTE BitMask );
void SetControlBit( PPORT *Port, BYTE BitMask );
void ClearControlBit( PPORT *Port, BYTE BitMask );
int LPT1_NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int LPT2_NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int LPT3_NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int BiDirUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int RLE_BiDirUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int RLE_NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int LPT1_BiDirUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int LPT2_BiDirUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int LPT3_BiDirUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes );
int LPT1_RLE_BiDirUpload( PPORT *Port,  BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int LPT2_RLE_BiDirUpload( PPORT *Port,  BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int LPT3_RLE_BiDirUpload( PPORT *Port,  BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int LPT1_RLE_NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int LPT2_RLE_NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int LPT3_RLE_NibbleUpload( PPORT *Port, BYTE __huge *Data, DWORD Bytes, DWORD *Received );
int readline(FILE *file, char *contents);
struct setup *lookup_setup(char *name, int sequence);
struct setup *install_setup_at_end_of_list(char *name, char *def);
struct setup *install_setup(char *name, char *def);
int set_setup(char *name, char *def);
int get_setup(char *name, char *def, int sequence);
int load_setup(char *home_dir);
int save_settings(char *home_dir);
void putimage(int xsize, int ysize);
int openwin(int argc, char *argv[], int xsize, int ysize);
unsigned char *getbuf(void);
void closewin(void);
int wingetdepth(void);
int resize_window(int xsize, int ysize);
